import { Client, Module, Input_callContractMethod, Input_callContractMethodAndWait, Input_sendTransaction, Input_sendTransactionAndWait, Input_deployContract, Input_signMessage, Input_sendRPC, TxResponse, TxReceipt } from "./w3";
import { EthereumConfig } from "../common/EthereumConfig";
export interface MutationConfig extends EthereumConfig, Record<string, unknown> {
}
export declare class Mutation extends Module<MutationConfig> {
    private _connections;
    private _defaultNetwork;
    constructor(config: MutationConfig);
    callContractMethod(input: Input_callContractMethod, _client: Client): Promise<TxResponse>;
    callContractMethodAndWait(input: Input_callContractMethodAndWait, _client: Client): Promise<TxReceipt>;
    sendTransaction(input: Input_sendTransaction, _client: Client): Promise<TxResponse>;
    sendTransactionAndWait(input: Input_sendTransactionAndWait, _client: Client): Promise<TxReceipt>;
    deployContract(input: Input_deployContract, _client: Client): Promise<string>;
    signMessage(input: Input_signMessage, _client: Client): Promise<string>;
    sendRPC(input: Input_sendRPC, _client: Client): Promise<string>;
    private _callContractMethod;
    private _getConnection;
}
