import { Client, Module, Input_callContractView, Input_callContractStatic, Input_getBalance, Input_encodeParams, Input_encodeFunction, Input_solidityPack, Input_solidityKeccak256, Input_soliditySha256, Input_getSignerAddress, Input_getSignerBalance, Input_getSignerTransactionCount, Input_getGasPrice, Input_estimateTransactionGas, Input_estimateContractCallGas, Input_checkAddress, Input_toWei, Input_toEth, Input_waitForEvent, Input_awaitTransaction, Input_getNetwork, BigInt, StaticTxResult, EventNotification, TxReceipt, Network } from "./w3";
import { EthereumConfig } from "../common/EthereumConfig";
export interface QueryConfig extends EthereumConfig, Record<string, unknown> {
}
export declare class Query extends Module<QueryConfig> {
    private _connections;
    private _defaultNetwork;
    constructor(config: QueryConfig);
    callContractView(input: Input_callContractView, _client: Client): Promise<string>;
    callContractStatic(input: Input_callContractStatic, _client: Client): Promise<StaticTxResult>;
    getBalance(input: Input_getBalance, _client: Client): Promise<BigInt>;
    encodeParams(input: Input_encodeParams, _client: Client): Promise<string>;
    encodeFunction(input: Input_encodeFunction, _client: Client): Promise<string>;
    solidityPack(input: Input_solidityPack, _client: Client): Promise<string>;
    solidityKeccak256(input: Input_solidityKeccak256, _client: Client): Promise<string>;
    soliditySha256(input: Input_soliditySha256, _client: Client): Promise<string>;
    getSignerAddress(input: Input_getSignerAddress, _client: Client): Promise<string>;
    getSignerBalance(input: Input_getSignerBalance, _client: Client): Promise<string>;
    getSignerTransactionCount(input: Input_getSignerTransactionCount, _client: Client): Promise<string>;
    getGasPrice(input: Input_getGasPrice, _client: Client): Promise<string>;
    estimateTransactionGas(input: Input_estimateTransactionGas, _client: Client): Promise<string>;
    estimateContractCallGas(input: Input_estimateContractCallGas, _client: Client): Promise<string>;
    checkAddress(input: Input_checkAddress, _client: Client): Promise<boolean>;
    toWei(input: Input_toWei, _client: Client): Promise<string>;
    toEth(input: Input_toEth, _client: Client): Promise<string>;
    waitForEvent(input: Input_waitForEvent, _client: Client): Promise<EventNotification>;
    awaitTransaction(input: Input_awaitTransaction): Promise<TxReceipt>;
    getNetwork(input: Input_getNetwork): Promise<Network>;
    private _getConnection;
}
